# coding: utf-8

"""
    apphub

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from apphub_client.models.apphub_v1_package_spec_deployment import ApphubV1PackageSpecDeployment
from apphub_client.models.apphub_v1_package_spec_environment import ApphubV1PackageSpecEnvironment
from apphub_client.models.apphub_v1_package_spec_source import ApphubV1PackageSpecSource
from typing import Optional, Set
from typing_extensions import Self

class ApphubV1PackageSpec(BaseModel):
    """
    PackageSpec includes source/deploy archives and the reference of environment to build the package.
    """ # noqa: E501
    buildcmd: Optional[StrictStr] = Field(default=None, description="BuildCommand is a custom build command that builder used to build the source archive.")
    deployment: Optional[ApphubV1PackageSpecDeployment] = None
    environment: ApphubV1PackageSpecEnvironment
    source: Optional[ApphubV1PackageSpecSource] = None
    __properties: ClassVar[List[str]] = ["buildcmd", "deployment", "environment", "source"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ApphubV1PackageSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of deployment
        if self.deployment:
            _dict['deployment'] = self.deployment.to_dict()
        # override the default output from pydantic by calling `to_dict()` of environment
        if self.environment:
            _dict['environment'] = self.environment.to_dict()
        # override the default output from pydantic by calling `to_dict()` of source
        if self.source:
            _dict['source'] = self.source.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ApphubV1PackageSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "buildcmd": obj.get("buildcmd"),
            "deployment": ApphubV1PackageSpecDeployment.from_dict(obj["deployment"]) if obj.get("deployment") is not None else None,
            "environment": ApphubV1PackageSpecEnvironment.from_dict(obj["environment"]) if obj.get("environment") is not None else None,
            "source": ApphubV1PackageSpecSource.from_dict(obj["source"]) if obj.get("source") is not None else None
        })
        return _obj


